# Wikipedia Scraper
Python Program for Wikipedia Scraping.

## Features
      1) Short Description of the page
      2) Dictionary content of Page Bio or vcard info
      3) Scraps all the table content to json (Pass True to args to extract along with links)

## How To Use
      1) Install required packages using
            >> pip install -r requirements.txt
      2) Change the wikipedia page link in scraper.py
      3) Run scraper.py

## Example
   Response for https://en.wikipedia.org/wiki/A._P._J._Abdul_Kalam
      
        {"short-description": "Avul Pakir Jainulabdeen Abdul Kalam (/\u02c8\u00e6bd\u0259l k\u0259\u02c8l\u0251\u02d0m/ (listen); 15 October 1931 \u2013 27 July 2015) was an Indian aerospace scientist and politician who served as the 11th President of India from 2002 to 2007. He was born and raised in Rameswaram, Tamil Nadu and studied physics and aerospace engineering. He spent the next four decades as a scientist and science administrator, mainly at the Defence Research and Development Organisation (DRDO) and Indian Space Research Organisation (ISRO) and was intimately involved in India's civilian space programme and military missile development efforts.[1] He thus came to be known as the Missile Man of India for his work on the development of ballistic missile and launch vehicle technology.[2][3][4] He also played a pivotal organisational, technical, and political role in India's Pokhran-II nuclear tests in 1998, the first since the original nuclear test by India in 1974.[5]\nKalam was elected as the 11th President of India in 2002 with the support of both the ruling Bharatiya Janata Party and the then-opposition Indian National Congress. Widely referred to as the \"People's President\",[6] he returned to his civilian life of education, writing and public service after a single term. He was a recipient of several prestigious awards, including the Bharat Ratna, India's highest civilian honour.\nWhile delivering a lecture at the Indian Institute of Management Shillong, Kalam collapsed and died from an apparent cardiac arrest on 27 July 2015, aged 83.[7] Thousands, including national-level dignitaries, attended the funeral ceremony held in his hometown of Rameshwaram, where he was buried with full state honours.[8]\n", 
        
            "Info-data": {"Prime Minister": "Atal Bihari Vajpayee Manmohan Singh", "Vice President": "Krishan Kant Bhairon Singh Shekhawat", "Preceded by": "K. R. Narayanan", "Succeeded by": "Pratibha Patil", "Born": "Avul Pakir Jainulabdeen Abdul Kalam (1931-10-15)15 October 1931 Rameswaram, Madras Presidency, British India (present-day Tamil Nadu, India)", "Died": "27 July 2015(2015-07-27) (aged\u00a083) Shillong, Meghalaya, India", "Resting place": "Pei Karumbu Ground, Rameswaram, Tamil Nadu, India", "Alma mater": "St. Joseph's College, Tiruchirappalli (BEng)Madras Institute of Technology (MEng)", "Profession": "Aerospace scientistAuthor", "Awards": "Full list", "Notable work(s)": "Wings of Fire, India 2020, Ignited Minds, Indomitable Spirit, Transcendence: My Spiritual Experiences with Pramukh Swamiji", "Signature": "", "Website": "abdulkalam.com", "Fields": "Aerospace Engineering", "Institutions": "Defence Research and Development Organisation Indian Space Research Organisation"},
 
            "Tabuler data": {"table1": [[], ["2014", "Honorary professor", "Beijing University, China[171][172]"], ["2014", "Doctor of Science", "Edinburgh University, UK[173]"], ["2013", "Von Braun Award", "National Space Society"], ["2012", "Doctor of Laws (Honoris Causa)", "Simon Fraser University[174]"], ["2011", "IEEE Honorary Membership", "IEEE[175]"], ["2010", "Doctor of Engineering", "University of Waterloo[176]"], ["2009", "Honorary Doctorate", "Oakland University[177]"], ["2009", "Hoover Medal", "ASME Foundation, USA[178]"], ["2009", "International von K\u00e1rm\u00e1n Wings Award", "California Institute of Technology, USA[179]"], ["2008", "Doctor of Engineering (Honoris Causa)", "Nanyang Technological University, Singapore[180]"], ["2008", "Doctor of Science (Honoris Causa)", "Aligarh Muslim University, Aligarh[181][182]"], ["2007", "Honorary Doctorate of Science and Technology", "Carnegie Mellon University[183]"], ["2007", "King Charles II Medal", "Royal Society, UK[184][185][186]"], ["2007", "Honorary Doctorate of Science", "University of Wolverhampton, UK[187]"], ["2000", "Ramanujan Award", "Alwars Research Centre, Chennai[188]"], ["1998", "Veer Savarkar Award", "Government of India[13]"], ["1997", "Indira Gandhi Award for National Integration", "Indian National Congress[13][188]"], ["1997", "Bharat Ratna", "Government of India[188][189]"], ["1995", "Honorary Fellow", "National Academy of Medical Sciences,[190]"], ["1994", "Distinguished Fellow", "Institute of Directors (India)[191]"], ["1990", "Padma Vibhushan", "Government of India[188][192]"], ["1981", "Padma Bhushan", "Government of India[188][192]"]], "table2": [["", "Wikimedia Commons has media related to Avul Pakir Jainulabdeen Abdul Kalam."]], "table3": [["", "Wikiquote has quotations related to: A. P. J. Abdul Kalam"]], "table4": [[], ["ListList by longevity"], ["Rajendra PrasadSarvepalli RadhakrishnanZakir HussainV. V. GiriFakhruddin Ali AhmedNeelam Sanjiva ReddyZail SinghR. VenkataramanShankar Dayal SharmaK. R. NarayananA. P. J. Abdul KalamPratibha PatilPranab MukherjeeRam Nath Kovind (incumbent)", ""], ["V. V. GiriMohammad HidayatullahB. D. Jatti"], ["EducationOfficial aircraftOfficial residencePresident's BodyguardPrevious experienceSpouses"]], "table5": [[], ["C. Rajagopalachari, Sarvepalli Radhakrishnan, and C. V. Raman (1954)Bhagwan Das, Mokshagundam Visvesvarayya, and Jawaharlal Nehru (1955)Govind Ballabh Pant (1957)Dhondo Keshav Karve (1958)", ""], ["Bidhan Chandra Roy and Purushottam Das Tandon (1961)Rajendra Prasad (1962)Zakir Husain and Pandurang Vaman Kane (1963)Lal Bahadur Shastri (1966)Indira Gandhi (1971)V. V. Giri (1975)K. Kamaraj (1976)Mother Teresa (1980)"], ["Vinoba Bhave (1983)Khan Abdul Ghaffar Khan (1987)M. G. Ramachandran (1988)B. R. Ambedkar and Nelson Mandela (1990)Rajiv Gandhi, Vallabhbhai Patel, and Morarji Desai (1991)Abul Kalam Azad, J. R. D. Tata, and Satyajit Ray (1992)Gulzarilal Nanda, Aruna Asaf Ali, and A. P. J. Abdul Kalam (1997)M. S. Subbulakshmi  and Chidambaram Subramaniam (1998)Jayaprakash Narayan, Amartya Sen, Gopinath Bordoloi, and Ravi Shankar (1999)"], ["Lata Mangeshkar and Bismillah Khan (2001)Bhimsen Joshi (2008)C. N. R. Rao and Sachin Tendulkar (2014)Madan Mohan Malaviya and Atal Bihari Vajpayee (2015)Nanaji Deshmukh, Bhupen Hazarika, and Pranab Mukherjee (2019)"]], "table6": [[], ["Ebrahim AlkaziKishori AmonkarAmitabh BachchanTeejan BaiM. BalamuralikrishnaT. BalasaraswatiAsha BhosleNandalal BoseHariprasad ChaurasiaGirija DeviKumar GandharvaAdoor GopalakrishnanSatish GujralGangubai HangalBhupen HazarikaM. F. HusainIlaiyaraajaSemmangudi Srinivasa IyerBhimsen JoshiAli Akbar KhanAmjad Ali KhanAllauddin KhanBismillah KhanGhulam Mustafa KhanYamini KrishnamurthyDilip KumarR. K. LaxmanBirju MaharajKishan MaharajLata MangeshkarSonal MansinghMallikarjun MansurZubin MehtaMario MirandaChhannulal MishraKelucharan MohapatraRaghunath MohapatraJasraj MotiramBenode Behari MukherjeeHrishikesh MukherjeeRajinikanthRam NarayanD. K. PattammalK. Shankar PillaiBalwant Moreshwar PurandareAkkineni Nageswara RaoKaloji Narayana RaoSatyajit RayS. H. RazaZohra SehgalUday ShankarRavi ShankarV. ShantaramShivkumar SharmaUmayalpuram K. SivaramanM. S. SubbulakshmiK. G. SubramanyanKapila VatsyayanHomai VyarawallaK. J. Yesudas"], ["Bimala Prasad ChalihaNaresh ChandraT. N. ChaturvediJayanto Nath ChaudhuriSuranjan DasRajeshwar DayalBasanti DeviP. N. DharJyotindra Nath DixitM. S. GillHafiz Mohamad IbrahimH. V. R. IyengarBhola Nath JhaDattatraya Shridhar JoshiAjudhiya Nath KhoslaRai KrishnadasaV. KrishnamurthyP. Prabhakar KumaramangalamPratap Chandra LalK. B. LallSam ManekshawOm Prakash MehraMohan Sinha MehtaM. G. K. MenonBrajesh MishraSumati MorarjeeA. Ramasamy MudaliarSardarilal Mathradas NandaChakravarthi V. NarasimhanBraj Kumar NehruBhairab Dutt PandeGhananand PandeVijaya Lakshmi PanditT. V. RajeswarC. R. Krishnaswamy RaoPattadakal Venkanna R. RaoV. K. R. V. RaoKhusro Faramurz RustamjiHarish Chandra SarinBinay Ranjan SenHomi SethnaArjan SinghHarbaksh SinghKirpal SinghManmohan SinghTarlok SinghLallan Prasad SinghBalaram SivaramanChandrika Prasad SrivastavaT. SwaminathanArun Shridhar VaidyaDharma ViraNarinder Nath Vohra"], ["V. S. R. ArunachalamJagdish BhagwatiSatyendra Nath BoseTara ChandSuniti Kumar ChatterjiD. P. ChattopadhyayaBhabatosh DattaAvinash DixitMahasweta DeviJohn Kenneth GalbraithSarvepalli GopalLakshman Shastri JoshiKaka KalelkarDhondo Keshav KarveGopinath KavirajKuvempuO. N. V. KurupPrasanta Chandra MahalanobisSitakant MahapatraJohn MathaiKotha Satchidananda MurthyGiani Gurmukh Singh MusafirBasanti Dulal NagchaudhuriBal Ram NandaR. K. NarayanP. ParameswaranAmrita PritamK. N. RajC. RangarajanRaja RaoRamoji RaoHormasji Maneckji SeervaiRajaram ShastriKalu Lal ShrimaliGovindbhai ShroffKhushwant SinghChandeshwar Prasad Narayan SinghPremlila Vithaldas ThackerseyMahadevi VarmaBashir Hussain Zaidi"], ["Jasbir Singh BajajB. K. GoyalPurshotam LalA. Lakshmanaswami MudaliarS. I. PadmavatiAutar Singh PaintalKantilal Hastimal SanchetiBalu SankaranV. ShantaVithal Nagesh ShirodkarPrakash Narain TandonBrihaspati Dev TrigunaM. S. Valiathan"], ["Sunderlal BahugunaB. K. S. IyengarRambhadracharyaRavi ShankarVishwesha TeerthaJaggi Vasudev"], ["L. K. AdvaniMontek Singh AhluwaliaAruna Asaf AliFazal AliAdarsh Sein AnandMadhav Shrihari AneyParkash Singh BadalSikander BakhtMilon K. BanerjiMirza Hameedullah BegP. N. BhagwatiRaja ChelliahChandra Kisan DaphtaryNiren DeC. D. DeshmukhAnthony Lancelot DiasUma Shankar DikshitKazi Lhendup DorjeeGeorge FernandesP. B. GajendragadkarBenjamin GilmanIsma\u00efl Omar GuellehZakir HusainV. R. Krishna IyerJagmohanLakshmi Chand JainArun JaitleyAditya Nath JhaMurli Manohar JoshiAnerood JugnauthMehdi Nawaz JungAli Yavar JungVijay KelkarHans Raj KhannaV. N. KhareBalasaheb Gangadhar KherAkhlaqur Rahman KidwaiJivraj Narayan MehtaV. K. Krishna MenonHirendranath MukherjeeAjoy MukherjeePranab MukherjeePadmaja NaiduGulzarilal NandaGovind NarainFali Sam NarimanHosei NorotaNanabhoy PalkhivalaK. ParasaranHari Vinayak PataskarSunder Lal PatwaSharad PawarNaryana Raghvan PillaiSri PrakasaN. G. RangaRavi Narayana ReddyY. Venugopal ReddyGhulam Mohammed SadiqLakshmi SahgalP. A. SangmaM. C. SetalvadKaran SinghNagendra SinghSwaran SinghWalter SisuluSoli SorabjeeKalyan SundaramSushma SwarajChandulal Madhavlal TrivediAtal Bihari VajpayeeM. N. VenkatachaliahKottayan Katankot VenugopalJigme Dorji Wangchuck"], ["V. K. AatreSalim AliNorman BorlaugSubrahmanyan ChandrasekharRajagopala ChidambaramCharles CorreaSatish DhawanAnil KakodkarA. P. J. Abdul KalamKrishnaswamy KasturiranganHar Gobind KhoranaDaulat Singh KothariVerghese KurienRaghunath Anant MashelkarG. Madhavan NairRoddam NarasimhaJayant NarlikarRajendra K. PachauriBenjamin Peary PalYash PalI. G. PatelVenkatraman RamakrishnanK. R. RamanathanRaja RamannaC. R. RaoC. N. R. RaoPalle Rama RaoUdupi Ramachandra RaoVikram SarabhaiMan Mohan SharmaObaid SiddiqiE. SreedharanM. R. SrinivasanGeorge SudarshanM. S. Swaminathan"], ["Baba AmtePandurang Shastri AthavaleJanaki Devi BajajMirabehnKamaladevi ChattopadhyayDurgabai DeshmukhNanaji DeshmukhNirmala DeshpandeMohan DhariaU. N. DhebarValerian GraciasVeerendra HeggadeMary Clubwala JadhavGaganvihari Lallubhai MehtaUsha MehtaSister NirmalaNellie Sengupta"], ["Viswanathan AnandEdmund HillaryMary KomSachin Tendulkar"], ["Dhirubhai AmbaniGhanshyam Das BirlaAshok Sekhar GangulyKarim Al Hussaini Aga KhanLakshmi MittalAnil Manibhai NaikN. R. Narayana MurthyM. NarasimhamPrithvi Raj Singh OberoiAzim PremjiPrathap C. ReddyJ. R. D. TataRatan Tata"], [" Portal Category WikiProject"]], "table7": [[], ["Sunil Gavaskar"], ["Vainu BappuPrafulla DesaiA. P. J. Abdul KalamGopinath MohantyPrabhat Kumar MukhopadhyayaAmritlal NagarMrinal SenAvabai Bomanji Wadia"], ["Jasbir Singh BajajS. BalachanderGottipati BrahmaiahRani GaidinliuKhadim Hussain KhanStella KramrischJal Minocher MehtaGrace MorleySyed Zahoor QasimKamal RanadiveP. N. Pattabhirama SastriJhabarmal SharmaAjit Ram Verma"], ["Richard AttenboroughDoraiswamy IyengarV. G. JogK. Sankaran NairPrem NazirSwraj Paul, Baron Paul RajkumarK. G. RamanathanKershasp Tehmurasp SatarawalaSubodh Chandra SenguptaAdi M. SethnaArun Kumar SharmaBenudhar SharmaBhalindra SinghUmrao Singh"], ["Horace AlexanderMichael FerreiraSivaji GanesanJnan Prakash GhoshKotha Satchidananda MurthyHosur NarasimhaiahSripada PinakapaniIshwari PrasadB. C. SanyalMarie SetonArchana SharmaObaid SiddiqiNatwar SinghGanda SinghVijay TendulkarBaldev Upadhyaya"], ["Durga Das BasuShiba P. ChatterjeeEknath Vasant ChitnisVirender Lal ChopraGurbaksh Singh DhillonSantidev GhoshBhimsen JoshiTribhuvandas LuharSadat Abul MasudKalanidhi NarayananBernard PetersThakazhi Sivasankara PillaiGopala RamanujamS. RamaseshanVuppuluri Ganapathi SastryAmarjit SinghGurbachan Singh TalibBhalchandra UdgaonkarSrinivasan Varadarajan"], ["Pushpa Mittra BhargavaEla BhattManohar Lal ChibberAminuddin DagarV. KrishnamurthyJean RiboudSidney Dillon RipleyRajeev SethiMartand SinghC. Venkataraman SundaramBadri Nath TandonGulshan Lal TandonR. K. Trivedi"], ["Balamani AmmaKishori AmonkarNikhil BanerjeeRoddam NarasimhaR. D. PradhanAnnada Shankar RayJulio RibeiroMan Mohan SharmaLaxmi Prasad SihareFarokh UdwadiaMohammad Yunus"], ["19th Kushok Bakula RinpocheRam Prakash BambahKartar Singh DuggalAshok Sekhar GangulyAbid HussainShreyans Prasad JainKelucharan MohapatraBal Ram NandaAkkineni Nageswara RaoPratury Trirumala RaoRenuka RayB. V. SreekantanSatya Pal Wahi"], ["Fenner Brockway, Baron BrockwayBanoo Jehangir CoyajiGirija DeviKattingeri Krishna HebbarGirilal JainAnna Rajam MalhotraM. V. MathurAshesh Prosad MitraRussi ModySuresh Shankar NadkarniNarinder Singh RandhawaYoshio SakurauchiLakshman SinghPrakash Narain Tandon"], ["# Posthumous conferral1954\u201319591960\u201319691970\u201319791980\u201319891990\u201319992000\u201320092010\u201320192020\u20132029"]], "table8": [[], ["AvionicsTejasAdvanced Medium Combat AircraftOther HAL programmesHJT-36HTT-40DhruvRudraLight Combat HelicopterLight Utility HelicopterUnmanned aerial vehiclesNishantRustomLakshyaKapothakaUlkaFluffyAURA UAVImperial EagleNetra", "TejasAdvanced Medium Combat Aircraft", "HJT-36HTT-40DhruvRudraLight Combat HelicopterLight Utility Helicopter", "NishantRustomLakshyaKapothakaUlkaFluffyAURA UAVImperial EagleNetra"], ["TejasAdvanced Medium Combat Aircraft"], ["HJT-36HTT-40DhruvRudraLight Combat HelicopterLight Utility Helicopter"], ["NishantRustomLakshyaKapothakaUlkaFluffyAURA UAVImperial EagleNetra"], ["Small armsINSASVidhwansakMSMCMCIWSArtillery systems and ammunitionPinaka Multi Barrel Rocket LauncherM-46 CatapultBhim-T6Dhanush Howitzer", "INSASVidhwansakMSMCMCIWS", "Pinaka Multi Barrel Rocket LauncherM-46 CatapultBhim-T6Dhanush Howitzer"], ["INSASVidhwansakMSMCMCIWS"], ["Pinaka Multi Barrel Rocket LauncherM-46 CatapultBhim-T6Dhanush Howitzer"], ["TanksArjunArjun Mk-IITank EXDRDO light tankInfantry fighting vehicleAbhay IFVOther vehiclesCarrier Mortar TrackedArmoured Engineer Reconnaissance VehicleLight Armoured VehicleKartik BLTDaksh", "ArjunArjun Mk-IITank EXDRDO light tank", "Abhay IFV", "Carrier Mortar TrackedArmoured Engineer Reconnaissance VehicleLight Armoured VehicleKartik BLTDaksh"], ["ArjunArjun Mk-IITank EXDRDO light tank"], ["Abhay IFV"], ["Carrier Mortar TrackedArmoured Engineer Reconnaissance VehicleLight Armoured VehicleKartik BLTDaksh"], ["Electronic warfareSamyuktaTarang RadarsINDRARajendra RadarSwordfish Long Range Tracking RadarMulti-mode radar3D Airborne Warning and ControlSuper Vision-2000BFSR-SR3D-CARSwathi Weapon Locating RadarSoftwareNETRA", "SamyuktaTarang ", "INDRARajendra RadarSwordfish Long Range Tracking RadarMulti-mode radar3D Airborne Warning and ControlSuper Vision-2000BFSR-SR3D-CARSwathi Weapon Locating Radar", "NETRA"], ["SamyuktaTarang "], ["INDRARajendra RadarSwordfish Long Range Tracking RadarMulti-mode radar3D Airborne Warning and ControlSuper Vision-2000BFSR-SR3D-CARSwathi Weapon Locating Radar"], ["NETRA"], ["Ballistic missilesAgniAgni-IAgni-IIAgni-IIIAgni-IVAgni-VAgni-VIPrithviIIIIIIDhanushSRBMShauryaPrahaarSLBMK-15K-4K-5Cruise missilesNirbhayBrahMosIIHSTDVAir-to-air missilesAstra BVRAAMDRDO Anti-Radiation MissileAnti-tank missilesNagDRDO Anti Tank MissileSurface-to-airAkashTrishulMaitri missileBarak 8QRSAMAir-to-surfaceHelinaBrahMos Air launched VariantAnti-ballisticPrithvi Air Defence (PAD)Advanced Air Defence (AAD)TorpedoesAdvanced Light Torpedo ShyenaVarunastra Heavy Weight Torpedo", "AgniAgni-IAgni-IIAgni-IIIAgni-IVAgni-VAgni-VIPrithviIIIIIIDhanushSRBMShauryaPrahaarSLBMK-15K-4K-5", "Agni-IAgni-IIAgni-IIIAgni-IVAgni-VAgni-VI", "IIIIIIDhanush", "ShauryaPrahaar", "K-15K-4K-5", "NirbhayBrahMosIIHSTDV", "Astra BVRAAMDRDO Anti-Radiation Missile", "NagDRDO Anti Tank Missile", "AkashTrishulMaitri missileBarak 8QRSAM", "HelinaBrahMos Air launched Variant", "Prithvi Air Defence (PAD)Advanced Air Defence (AAD)", "Advanced Light Torpedo ShyenaVarunastra Heavy Weight Torpedo"], ["AgniAgni-IAgni-IIAgni-IIIAgni-IVAgni-VAgni-VIPrithviIIIIIIDhanushSRBMShauryaPrahaarSLBMK-15K-4K-5", "Agni-IAgni-IIAgni-IIIAgni-IVAgni-VAgni-VI", "IIIIIIDhanush", "ShauryaPrahaar", "K-15K-4K-5"], ["Agni-IAgni-IIAgni-IIIAgni-IVAgni-VAgni-VI"], ["IIIIIIDhanush"], ["ShauryaPrahaar"], ["K-15K-4K-5"], ["NirbhayBrahMosIIHSTDV"], ["Astra BVRAAMDRDO Anti-Radiation Missile"], ["NagDRDO Anti Tank Missile"], ["AkashTrishulMaitri missileBarak 8QRSAM"], ["HelinaBrahMos Air launched Variant"], ["Prithvi Air Defence (PAD)Advanced Air Defence (AAD)"], ["Advanced Light Torpedo ShyenaVarunastra Heavy Weight Torpedo"], ["Laser-guidedSudarshan Smart Anti-Airfield Weapon", "Sudarshan Smart Anti-Airfield Weapon"], ["Sudarshan Smart Anti-Airfield Weapon"], ["ScientistsMaj General Ranjit Lal JetleyRam Narain AgarwalA. P. J. Abdul KalamA. Sivathanu PillaiW SelvamurthyV. K. SaraswatV. K. AatreRaja RamannaV. S. MahalingamKeshav Dattatreya NayakTessy ThomasShashikala SinhaIpsita Biswas", "Maj General Ranjit Lal JetleyRam Narain AgarwalA. P. J. Abdul KalamA. Sivathanu PillaiW SelvamurthyV. K. SaraswatV. K. AatreRaja RamannaV. S. MahalingamKeshav Dattatreya NayakTessy ThomasShashikala SinhaIpsita Biswas"], ["Maj General Ranjit Lal JetleyRam Narain AgarwalA. P. J. Abdul KalamA. Sivathanu PillaiW SelvamurthyV. K. SaraswatV. K. AatreRaja RamannaV. S. MahalingamKeshav Dattatreya NayakTessy ThomasShashikala SinhaIpsita Biswas"], ["GTX 37-14UGTX-35VS KaveriKaveri Marine Gas TurbineGATET engine"], ["Project IndigoProject ValiantProject DevilIGMDPIndian Ballistic Missile Defence ProgrammeDYSLs"], ["Indian Missile ProgrammeIndian Armed Forces"]], "table9": [["TejasAdvanced Medium Combat Aircraft"], ["HJT-36HTT-40DhruvRudraLight Combat HelicopterLight Utility Helicopter"], ["NishantRustomLakshyaKapothakaUlkaFluffyAURA UAVImperial EagleNetra"]], "table10": [["INSASVidhwansakMSMCMCIWS"], ["Pinaka Multi Barrel Rocket LauncherM-46 CatapultBhim-T6Dhanush Howitzer"]], "table11": [["ArjunArjun Mk-IITank EXDRDO light tank"], ["Abhay IFV"], ["Carrier Mortar TrackedArmoured Engineer Reconnaissance VehicleLight Armoured VehicleKartik BLTDaksh"]], "table12": [["SamyuktaTarang "], ["INDRARajendra RadarSwordfish Long Range Tracking RadarMulti-mode radar3D Airborne Warning and ControlSuper Vision-2000BFSR-SR3D-CARSwathi Weapon Locating Radar"], ["NETRA"]], "table13": [["AgniAgni-IAgni-IIAgni-IIIAgni-IVAgni-VAgni-VIPrithviIIIIIIDhanushSRBMShauryaPrahaarSLBMK-15K-4K-5", "Agni-IAgni-IIAgni-IIIAgni-IVAgni-VAgni-VI", "IIIIIIDhanush", "ShauryaPrahaar", "K-15K-4K-5"], ["Agni-IAgni-IIAgni-IIIAgni-IVAgni-VAgni-VI"], ["IIIIIIDhanush"], ["ShauryaPrahaar"], ["K-15K-4K-5"], ["NirbhayBrahMosIIHSTDV"], ["Astra BVRAAMDRDO Anti-Radiation Missile"], ["NagDRDO Anti Tank Missile"], ["AkashTrishulMaitri missileBarak 8QRSAM"], ["HelinaBrahMos Air launched Variant"], ["Prithvi Air Defence (PAD)Advanced Air Defence (AAD)"], ["Advanced Light Torpedo ShyenaVarunastra Heavy Weight Torpedo"]], "table14": [["Agni-IAgni-IIAgni-IIIAgni-IVAgni-VAgni-VI"], ["IIIIIIDhanush"], ["ShauryaPrahaar"], ["K-15K-4K-5"]], "table15": [["Sudarshan Smart Anti-Airfield Weapon"]], "table16": [["Maj General Ranjit Lal JetleyRam Narain AgarwalA. P. J. Abdul KalamA. Sivathanu PillaiW SelvamurthyV. K. SaraswatV. K. AatreRaja RamannaV. S. MahalingamKeshav Dattatreya NayakTessy ThomasShashikala SinhaIpsita Biswas"]], "table17": [[], ["Department of Space (DoS)"], ["Indian Space Research Organisation (ISRO)Antrix CorporationIndian Institute of Space Science and Technology (IIST)Indian Institute of Remote Sensing (IIRS)Laboratory for Electro-Optics Systems (LEOS)National Atmospheric Research Laboratory (NARL)New Space India Limited (NSIL)Physical Research Laboratory (PRL)Development and Educational Communication Unit (DECU)Integrated Space CellDefence Space AgencyIndian National Space Promotion and Authorisation Centre (IN\u2013SPACe)", ""], ["BhaskaraGAGANGSATINSATIRNSSIRSCartosatRISATRohiniSROSSChandrayaanHuman Spaceflight Programme"], ["APPLEAryabhataHAMSATIMS-1Megha-TropiquesNISARSARALSouth Asia SatelliteSRESRE IIKalpana-1CARE"], ["AstrosatAditya-L1 (planned)XPoSat (planned)AstroSat-2 (proposed)"], ["Chandrayaan-1Chandrayaan-2Chandrayaan-3 (planned, 2021)Lunar Polar Exploration Mission (proposed)Mars Orbiter MissionMars Orbiter Mission 2 (proposed)Shukrayaan-1 (proposed)"], ["Gaganyaan (Under development)"], ["EnginesCE-7.5CE-20VikasOrbitalSLVASLVPSLVGSLVMk IMk IIMk IIISuborbitalRohiniATVConceptsULVUnder developmentRLV Technology Demonstration ProgrammeRLV-TDHEXSSLVSCE-200"], ["Indian Deep Space Network (IDSN)ISRO Satellite Centre (ISAC)ISRO Telemetry, Tracking and Command Network (ISTRAC)Master Control Facility (MCF)Satish Dhawan Space Centre (SDSC)Thumba Equatorial Rocket Launching Station (TERLS)ISRO Satellite Integration and Testing Establishment (ISITE)Vikram Sarabhai Space Center (VSSC)Liquid Propulsion Systems Centre (LPSC)ISRO Propulsion ComplexHuman Space Flight Centre (HSFC)"], ["Space Activities Bill"], ["SAGA-220 (supercomputer)RESPOND"], ["List of Indian satellitesList of Satish Dhawan Space Centre launchesList of ISRO missionsList of ISRO chairpersons"]], "table18": [[], ["TrombayPokhranCIRUS reactorRajasthanThar Desert"], ["Defence Research and Development OrganisationTerminal Ballistics Research LaboratoryHigh Energy Materials Research LaboratoryBhabha Atomic Research Centre"], ["Indira GandhiJagjivan RamTapishwar Narain RainaSwaran Singh"], ["Raja RamannaHomi SethnaWaman Dattatreya PatwardhanP. K. IyengarRajagopala ChidambaramRavi GroverAnil KakodkarA. K. GangulyM. P. Parameswaran"], ["Indian nuclear programmeHistory of nuclear weaponsPokhran-II (May 13, 1998)Indo-American nuclear dealNuclear proliferation"], ["See also: Nuclear power in India"]], "table19": [["BNF: cb13756488m (data)CANTIC: a11179582GND: 124468047ISNI: 0000 0000 8128 1158LCCN: n98925888NDL: 01087382NLA: 41505655NLI: 004940823NLK: KAC200902737NTA: 326558217SUDOC: 061027200Trove: 1440106VIAF: 49404258 WorldCat Identities: lccn-n98925888"]]}}
